package ictag.gui;
import ictag.domain.Book;
import ictag.util.DataBaseHelper;
import ictag.util.Resource;

import java.awt.BorderLayout;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.net.URL;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import org.apache.commons.jxpath.JXPathContext;
import org.apache.commons.jxpath.xml.DocumentContainer;

import pnuts.awt.PnutsLayout;

public class BookDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	private JPanel jContentPane = null;
	private JPanel bookInfoPanel = null;
	private JLabel icTagLabel = null;
	private JTextField jICTagField = null;
	private JLabel isbnLabel = null;
	private JTextField icbnField = null;
	private JPanel cmdPanel = null;
	private JButton isbnSearch = null;
	private JButton okButton = null;
	private JLabel titleLabel = null;
	private JLabel authorLabel = null;
	private JLabel publisherLabel = null;
	private JTextField publisherField = null;

	// 
	private JDialog	thisDialog;
	private JTextArea titleArea = null;
	private JLabel publicationDateLabel = null;
	private JTextField publicationDateField = null;
	private JLabel noPagesLabel = null;
	private JTextField noPagesField = null;
	private JLabel listPriceLabel = null;
	private JTextField listPriceField = null;
	private JScrollPane titleScroller = null;
	private JScrollPane authorScroller = null;
	private JTextArea authorArea = null;
	
	//
	protected Book		book;
	protected boolean	canceled = true;
	private JLabel shelfIdLabel = null;
	private JTextField shelfIdField = null;
	private JButton cancelButton = null;
	
	/**
	 * @param owner
	 */
	public BookDialog(Frame owner, Book book) {
		super(owner);
		this.thisDialog = this;
		this.book = book;
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(327, 338);
		this.setContentPane(getJContentPane());
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(new BorderLayout());
			jContentPane.add(getBookInfoPanel(), BorderLayout.CENTER);
			jContentPane.add(getCmdPanel(), BorderLayout.SOUTH);
		}
		return jContentPane;
	}

	/**
	 * This method initializes bookInfoPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getBookInfoPanel() {
		if (bookInfoPanel == null) {
			shelfIdLabel = new JLabel();
			shelfIdLabel.setText(Resource.getString("book.shelfID") + ":");
			listPriceLabel = new JLabel();
			listPriceLabel.setText(Resource.getString("book.price") + ":");
			noPagesLabel = new JLabel();
			noPagesLabel.setText(Resource.getString("book.pages") + ":");
			publicationDateLabel = new JLabel();
			publicationDateLabel.setText(Resource.getString("book.publicationDate") + ":");
			publisherLabel = new JLabel();
			publisherLabel.setText(Resource.getString("book.publisher") + ":");
			authorLabel = new JLabel();
			authorLabel.setText(Resource.getString("book.author") + ":");
			titleLabel = new JLabel();
			titleLabel.setText(Resource.getString("book.title") + ":");
			isbnLabel = new JLabel();
			isbnLabel.setText(Resource.getString("book.ISBN") + ":");
			icTagLabel = new JLabel();
			icTagLabel.setText(Resource.getString("book.ictagID") + ":");
			bookInfoPanel = new JPanel();
			bookInfoPanel.setLayout(new PnutsLayout("cols=2,halign=left,padx=5,pady=2"));
			//bookInfoPanel.setLayout(new GridLayout(8,2));
			bookInfoPanel.add(icTagLabel, null);
			bookInfoPanel.add(getJICTagField(), null);
			bookInfoPanel.add(isbnLabel, null);
			bookInfoPanel.add(getIcbnField(), null);
			bookInfoPanel.add(titleLabel, null);
			bookInfoPanel.add(getTitleScroller(), null);
			bookInfoPanel.add(authorLabel, null);
			bookInfoPanel.add(getAuthorScroller(), null);
			bookInfoPanel.add(publisherLabel, null);
			bookInfoPanel.add(getPublisherField(), null);
			bookInfoPanel.add(publicationDateLabel, null);
			bookInfoPanel.add(getPublicationDateField(), null);
			bookInfoPanel.add(noPagesLabel, null);
			bookInfoPanel.add(getNoPagesField(), null);
			bookInfoPanel.add(listPriceLabel, null);
			bookInfoPanel.add(getListPriceField(), null);
			bookInfoPanel.add(shelfIdLabel, null);
			bookInfoPanel.add(getShelfIdField(), null);
		}
		return bookInfoPanel;
	}

	/**
	 * This method initializes jICTagField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getJICTagField() {
		if (jICTagField == null) {
			jICTagField = new JTextField();
			jICTagField.setColumns(12);
			jICTagField.setEditable(false);
			jICTagField.setFocusable(false);
			if (book.getIcTag() != null)
				jICTagField.setText(book.getIcTag());
		}
		return jICTagField;
	}

	/**
	 * This method initializes icbnField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getIcbnField() {
		if (icbnField == null) {
			icbnField = new JTextField();
			icbnField.setColumns(13);
			if (book.getIsbn() != null)
				icbnField.setText(book.getIsbn());
		}
		return icbnField;
	}

	/**
	 * This method initializes cmdPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getCmdPanel() {
		if (cmdPanel == null) {
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
			gridBagConstraints.gridx = 2;
			gridBagConstraints.gridy = 0;
			cmdPanel = new JPanel();
			cmdPanel.setLayout(new GridBagLayout());
			cmdPanel.add(getIsbnSearch(), new GridBagConstraints());
			cmdPanel.add(getOkButton(), new GridBagConstraints());
			cmdPanel.add(getCancelButton(), gridBagConstraints);
		}
		return cmdPanel;
	}

	/**
	 * This method initializes isbnSearch	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getIsbnSearch() {
		if (isbnSearch == null) {
			isbnSearch = new JButton();
			isbnSearch.setText(Resource.getString("dialog.searchISBN"));
			isbnSearch.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					searchISBN();
				}
			});
			if (DataBaseHelper.getAwsAccessKeyID().length() == 0)
				isbnSearch.setEnabled(false);
		}
		return isbnSearch;
	}

	/**
	 * This method initializes okButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getOkButton() {
		if (okButton == null) {
			okButton = new JButton();
			okButton.setText(Resource.getString("dialog.ok"));
			okButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					try {
						book.setIcTag(getJICTagField().getText());
						book.setIsbn(getIcbnField().getText());
						book.setTitle(getTitleArea().getText());
						book.setAuthor(getAuthorArea().getText());
						book.setPublisher(getPublisherField().getText());
						book.setPublicationDate(getPublicationDateField().getText());
						book.setNoPages(getNoPagesField().getText());
						book.setListPrice(getListPriceField().getText());
						book.setShelfId(getShelfIdField().getText());
						DataBaseHelper.saveBook(book);
					}
					catch (Exception ex) {
						ex.printStackTrace();
					}
					thisDialog.dispose();
					canceled = false;
				}
			});
		}
		return okButton;
	}

	/**
	 * This method initializes publisherField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getPublisherField() {
		if (publisherField == null) {
			publisherField = new JTextField();
			publisherField.setColumns(15);
			if (book.getPublisher() != null)
				publisherField.setText(book.getPublisher());
		}
		return publisherField;
	}

	private void searchISBN() {
		String requestUrl = "http://webservices.amazon.co.jp/onca/xml?Service=AWSECommerceService&SubscriptionId=" + DataBaseHelper.getAwsAccessKeyID() + "&Operation=ItemSearch&ResponseGroup=Medium&SearchIndex=Blended&Keywords="
				+ getIcbnField().getText();
		try {
			DocumentContainer container = new DocumentContainer(new URL(
					requestUrl));
			container.setNamespaceAware(true);
			JXPathContext context = JXPathContext.newContext(container);
			context.registerNamespace("aws",
							"http://webservices.amazon.com/AWSECommerceService/2005-10-05");

			String title = context.getValue("//aws:Title").toString();
			String author = context.getValue("//aws:Author").toString();
			int numOfAuthor = (int)Double.parseDouble(context.getValue("count(//aws:Author)").toString());
		
			for (int i = 1; i < numOfAuthor; i++) {
				String nextAuthor = "//aws:Author[" + (i+1) + "]";
				author = author + "; " + context.getValue(nextAuthor).toString();
			}

			String publisher = context.getValue("//aws:Manufacturer").toString();
			String publicationDate = context.getValue("//aws:PublicationDate").toString();
			String noPages = context.getValue("//aws:NumberOfPages").toString();
			String listPrice = context.getValue("//aws:Amount").toString();
			
			titleArea.setText(title);
			authorArea.setText(author);
			publisherField.setText(publisher);
			publicationDateField.setText(publicationDate);
			noPagesField.setText(noPages);
			listPriceField.setText(listPrice);

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * This method initializes titleArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getTitleArea() {
		if (titleArea == null) {
			titleArea = new JTextArea();
			titleArea.setColumns(16);
			titleArea.setLineWrap(true);
			titleArea.setRows(2);
			if (book.getTitle() != null)
				titleArea.setText(book.getTitle());
		}
		return titleArea;
	}

	/**
	 * This method initializes publicationDateField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getPublicationDateField() {
		if (publicationDateField == null) {
			publicationDateField = new JTextField();
			publicationDateField.setColumns(7);
			if (book.getPublicationDate() != null)
				publicationDateField.setText(book.getPublicationDate());
		}
		return publicationDateField;
	}

	/**
	 * This method initializes noPagesField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getNoPagesField() {
		if (noPagesField == null) {
			noPagesField = new JTextField();
			noPagesField.setColumns(3);
			if (book.getNoPages() != null)
				noPagesField.setText(book.getNoPages());
		}
		return noPagesField;
	}

	/**
	 * This method initializes listPriceField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getListPriceField() {
		if (listPriceField == null) {
			listPriceField = new JTextField();
			listPriceField.setColumns(5);
			if (book.getListPrice() != null)
				listPriceField.setText(book.getListPrice());
		}
		return listPriceField;
	}

	/**
	 * This method initializes jTitleScroller	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getTitleScroller() {
		if (titleScroller == null) {
			titleScroller = new JScrollPane();
			titleScroller.setViewportView(getTitleArea());
		}
		return titleScroller;
	}

	/**
	 * This method initializes authorScroller	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getAuthorScroller() {
		if (authorScroller == null) {
			authorScroller = new JScrollPane();
			authorScroller.setViewportView(getAuthorArea());
		}
		return authorScroller;
	}

	/**
	 * This method initializes authorArea	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getAuthorArea() {
		if (authorArea == null) {
			authorArea = new JTextArea();
			authorArea.setColumns(16);
			authorArea.setLineWrap(true);
			authorArea.setRows(2);
			if (book.getAuthor() != null)
				authorArea.setText(book.getAuthor());
		}
		return authorArea;
	}

	public boolean isCanceled() {
		return canceled;
	}

	/**
	 * This method initializes shelfIdField	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getShelfIdField() {
		if (shelfIdField == null) {
			shelfIdField = new JTextField();
			shelfIdField.setColumns(4);
			if (book.getShelfId() != null)
				shelfIdField.setText(book.getShelfId());
		}
		return shelfIdField;
	}

	/**
	 * This method initializes cancelButton	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getCancelButton() {
		if (cancelButton == null) {
			cancelButton = new JButton();
			cancelButton.setText(Resource.getString("dialog.cancel"));
			cancelButton.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					thisDialog.dispose();
				}
			});
		}
		return cancelButton;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
